﻿Public Class Tresorknacker
    Public Code As String
    Dim SpielLäuft As Boolean = False
    Dim Eingabe As String = ""
    Dim Code_gesplittet() As String
    Public Spiel_Gewonnen As Boolean = False
    Private Sub Tresorknacker_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Menü.Hide()
        txtCode_sperren()
        lblCode_sperren()
    End Sub

    Private Sub Tresorknacker_FormClosed(sender As Object, e As FormClosedEventArgs) Handles MyBase.FormClosed
        Menü.Show()
    End Sub
    Sub txtCode_sperren()
        txtCode1.Enabled = False
        txtCode2.Enabled = False
        txtCode3.Enabled = False
        txtCode4.Enabled = False
        txtCode5.Enabled = False
        txtCode6.Enabled = False
        txtCode7.Enabled = False
        txtCode8.Enabled = False
    End Sub

    Sub txtCode_entsperren()
        txtCode1.Enabled = True
        txtCode2.Enabled = True
        txtCode3.Enabled = True
        txtCode4.Enabled = True
        txtCode5.Enabled = True
        txtCode6.Enabled = True
        txtCode7.Enabled = True
        txtCode8.Enabled = True
    End Sub

    Sub lblCode_sperren()
        lblCode1.Enabled = False
        lblCode2.Enabled = False
        lblCode3.Enabled = False
        lblCode4.Enabled = False
        lblCode5.Enabled = False
        lblCode6.Enabled = False
        lblCode7.Enabled = False
        lblCode8.Enabled = False
    End Sub

    Sub lblCode_entsperren()
        lblCode1.Enabled = True
        lblCode2.Enabled = True
        lblCode3.Enabled = True
        lblCode4.Enabled = True
        lblCode5.Enabled = True
        lblCode6.Enabled = True
        lblCode7.Enabled = True
        lblCode8.Enabled = True
    End Sub

    Function Code_generieren() As String 'Generiert einen vierstelligen Code zwischen 0 und 9 im Format 1-2-3-4, um den Code Splitten zu können
        Dim Code As String
        Dim rnd As New Random

        Code = rnd.Next(0, 10) & "-" & rnd.Next(0, 10) & "-" & rnd.Next(0, 10) & "-" & rnd.Next(0, 10)
        Return Code
    End Function

    Function Eingabe_prüfen() As String

        'Die Eingabe in vier Teile aufteilen 
        Dim txt_Eingabe() As String = Eingabe.Split(CType("-", Char()))

        'Prüfen, ob alle vier Teile der Eingabe Zahlen sind
        For i As Integer = 0 To 3
            If IsNumeric(txt_Eingabe(i)) = False Then
                Eingabe = ""
                Return ""
                Exit Function
            End If
        Next

        'Den generierten Code ins splitten (Code_gesplittet ist ein Array)
        Code_gesplittet = Code.Split(CType("-", Char()))

        'Den gsplitteten Code aus dem Array herausholen und im Format 1234 speichern
        Dim Code_ungesplittet As String = ""
        For x As Integer = 0 To 3
            Code_ungesplittet = Code_ungesplittet & Code_gesplittet(x)
        Next


        'Prüfen, welcher Teil der Eingabe mit dem Code übereinstimmt
        Dim lbl_text As String = ""
        For a As Integer = 0 To 3
            If txt_Eingabe(a) = Code_gesplittet(a) Then
                lbl_text = lbl_text & txt_Eingabe(a)
            Else
                lbl_text = lbl_text & "X"
            End If
        Next

        'Prüfen, ob der Code schon ganz erraten wurde
        If lbl_text = Code_ungesplittet Then
            Return "fertig"
        Else
            Return lbl_text
        End If

    End Function

    Private Sub CmdBeginnen_Click(sender As Object, e As EventArgs) Handles cmdBeginnen.Click
        If SpielLäuft = False Then

            'Einen zufälligen Code erhalten
            Code = Code_generieren()

            'Speichern, dass gerade ein Spiel läuft
            SpielLäuft = True

            'Die erste Eingabe freigeben
            Versuch_1()

        Else
            Exit Sub
        End If
    End Sub

    Private Sub TxtCode1_KeyDown(sender As Object, e As KeyEventArgs) Handles txtCode1.KeyDown

        If e.KeyCode = Keys.Enter Then

            'Die Eingabe speichern
            Eingabe = txtCode1.Text

            'Die Eingabe auf einen Treffer prüfen
            Dim Ergebnis As String = Eingabe_prüfen()

            'Anzeigen, ob es einen Treffer gab und bei Versuch 2 weitermachen
            If IsNothing(Ergebnis) Then
                lblCode1.Text = "XXXX"
            ElseIf Ergebnis <> "" Then
                If Ergebnis = "fertig" Then
                    Gewonnen()
                Else
                    txtCode1.Enabled = False
                    lblCode1.Text = Ergebnis
                    lblCode1.Enabled = False
                    Versuch_2()
                End If
            End If
        End If
    End Sub

    Private Sub TxtCode2_KeyDown(sender As Object, e As KeyEventArgs) Handles txtCode2.KeyDown
        If e.KeyCode = Keys.Enter Then

            'Die Eingabe speichern
            Eingabe = txtCode2.Text

            'Die Eingabe auf einen Treffer prüfen
            Dim Ergebnis As String = Eingabe_prüfen()

            'Anzeigen, ob es einen Treffer gab und bei Versuch 3 weitermachen
            If IsNothing(Ergebnis) Then
                lblCode2.Text = "XXXX"
            ElseIf Ergebnis <> "" Then
                If Ergebnis = "fertig" Then
                    Gewonnen()
                Else
                    txtCode2.Enabled = False
                    lblCode2.Text = Ergebnis
                    lblCode2.Enabled = False
                    Versuch_3()
                End If
            End If
        End If
    End Sub

    Private Sub TxtCode3_KeyDown(sender As Object, e As KeyEventArgs) Handles txtCode3.KeyDown
        If e.KeyCode = Keys.Enter Then

            'Die Eingabe speichern
            Eingabe = txtCode3.Text

            'Die Eingabe auf einen Treffer prüfen
            Dim Ergebnis As String = Eingabe_prüfen()

            'Anzeigen, ob es einen Treffer gab und bei Versuch 4 weitermachen
            If IsNothing(Ergebnis) Then
                lblCode3.Text = "XXXX"
            ElseIf Ergebnis <> "" Then
                If Ergebnis = "fertig" Then
                    Gewonnen()
                Else
                    txtCode3.Enabled = False
                    lblCode3.Text = Ergebnis
                    lblCode3.Enabled = False
                    Versuch_4()
                End If
            End If
        End If
    End Sub

    Private Sub TxtCode4_KeyDown(sender As Object, e As KeyEventArgs) Handles txtCode4.KeyDown
        If e.KeyCode = Keys.Enter Then

            'Die Eingabe speichern
            Eingabe = txtCode4.Text

            'Die Eingabe auf einen Treffer prüfen
            Dim Ergebnis As String = Eingabe_prüfen()

            'Anzeigen, ob es einen Treffer gab und bei Versuch 5 weitermachen
            If IsNothing(Ergebnis) Then
                lblCode4.Text = "XXXX"
            ElseIf Ergebnis <> "" Then
                If Ergebnis = "fertig" Then
                    Gewonnen()
                Else
                    txtCode4.Enabled = False
                    lblCode4.Text = Ergebnis
                    lblCode4.Enabled = False
                    Versuch_5()
                End If
            End If
        End If
    End Sub

    Private Sub TxtCode5_KeyDown(sender As Object, e As KeyEventArgs) Handles txtCode5.KeyDown
        If e.KeyCode = Keys.Enter Then

            'Die Eingabe speichern
            Eingabe = txtCode5.Text

            'Die Eingabe auf einen Treffer prüfen
            Dim Ergebnis As String = Eingabe_prüfen()

            'Anzeigen, ob es einen Treffer gab und bei Versuch 6 weitermachen
            If IsNothing(Ergebnis) Then
                lblCode5.Text = "XXXX"
            ElseIf Ergebnis <> "" Then
                If Ergebnis = "fertig" Then
                    Gewonnen()
                Else
                    txtCode5.Enabled = False
                    lblCode5.Text = Ergebnis
                    lblCode5.Enabled = False
                    Versuch_6()
                End If
            End If
        End If
    End Sub

    Private Sub TxtCode6_KeyDown(sender As Object, e As KeyEventArgs) Handles txtCode6.KeyDown
        If e.KeyCode = Keys.Enter Then

            'Die Eingabe speichern
            Eingabe = txtCode6.Text

            'Die Eingabe auf einen Treffer prüfen
            Dim Ergebnis As String = Eingabe_prüfen()

            'Anzeigen, ob es einen Treffer gab und bei Versuch 7 weitermachen
            If IsNothing(Ergebnis) Then
                lblCode6.Text = "XXXX"
            ElseIf Ergebnis <> "" Then
                If Ergebnis = "fertig" Then
                    Gewonnen()
                Else
                    txtCode6.Enabled = False
                    lblCode6.Text = Ergebnis
                    lblCode6.Enabled = False
                    Versuch_7()
                End If
            End If
        End If
    End Sub

    Private Sub TxtCode7_KeyDown(sender As Object, e As KeyEventArgs) Handles txtCode7.KeyDown
        If e.KeyCode = Keys.Enter Then

            'Die Eingabe speichern
            Eingabe = txtCode7.Text

            'Die Eingabe auf einen Treffer prüfen
            Dim Ergebnis As String = Eingabe_prüfen()

            'Anzeigen, ob es einen Treffer gab und bei Versuch 8 weitermachen
            If IsNothing(Ergebnis) Then
                lblCode2.Text = "XXXX"
            ElseIf Ergebnis <> "" Then
                If Ergebnis = "fertig" Then
                    Gewonnen()
                Else
                    txtCode7.Enabled = False
                    lblCode7.Text = Ergebnis
                    lblCode7.Enabled = False
                    Versuch_8()
                End If
            End If
        End If
    End Sub

    Private Sub TxtCode8_KeyDown(sender As Object, e As KeyEventArgs) Handles txtCode8.KeyDown
        If e.KeyCode = Keys.Enter Then

            'Die Eingabe speichern
            Eingabe = txtCode8.Text

            'Die Eingabe auf einen Treffer prüfen
            Dim Ergebnis As String = Eingabe_prüfen()

            'Anzeigen, ob es einen Treffer gab und ob man gewonnen hat
            If IsNothing(Ergebnis) Then
                lblCode8.Text = "XXXX"
            ElseIf Ergebnis <> "" Then
                If Ergebnis = "fertig" Then
                    Gewonnen()
                Else
                    txtCode8.Enabled = False
                    lblCode8.Text = Ergebnis
                    lblCode8.Enabled = False
                    Verloren()
                End If
            End If
        End If
    End Sub
    Sub Versuch_1()
        txtCode1.Enabled = True
        txtCode1.Focus()
        lblCode1.Enabled = True
    End Sub
    Sub Versuch_2()
        txtCode2.Enabled = True
        txtCode2.Focus()
        lblCode2.Enabled = True
    End Sub

    Sub Versuch_3()
        txtCode3.Enabled = True
        txtCode3.Focus()
        lblCode3.Enabled = True
    End Sub

    Sub Versuch_4()
        txtCode4.Enabled = True
        txtCode4.Focus()
        lblCode4.Enabled = True
    End Sub

    Sub Versuch_5()
        txtCode5.Enabled = True
        txtCode5.Focus()
        lblCode5.Enabled = True
    End Sub

    Sub Versuch_6()
        txtCode6.Enabled = True
        txtCode6.Focus()
        lblCode6.Enabled = True
    End Sub

    Sub Versuch_7()
        txtCode7.Enabled = True
        txtCode7.Focus()
        lblCode7.Enabled = True
    End Sub

    Sub Versuch_8()
        txtCode8.Enabled = True
        txtCode8.Focus()
        lblCode8.Enabled = True
    End Sub

    Sub Gewonnen()
        'MessageBox.Show("Gewonnen. Du kannst unbeobachtet mit dem Zaster verschwinden.", "Tresorknacker", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Spiel_Gewonnen = True
        Meldung.ShowDialog(Me)
        cmdAbbrechen.PerformClick() 'Alles wieder zurücksetzen
    End Sub

    Sub Verloren()
        'MessageBox.Show("Verloren. Die Polizei hat das Haus umstellt. Der Code war " & Code & " .", "Tresorknacker", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Spiel_Gewonnen = False
        Meldung.ShowDialog(Me)
        cmdAbbrechen.PerformClick() 'Alles wieder zurücksetzen
    End Sub
    Private Sub CmdAbbrechen_Click(sender As Object, e As EventArgs) Handles cmdAbbrechen.Click

        'Textboxen zurücksetzen
        txtCode1.Text = ""
        txtCode2.Text = ""
        txtCode3.Text = ""
        txtCode4.Text = ""
        txtCode5.Text = ""
        txtCode6.Text = ""
        txtCode7.Text = ""
        txtCode8.Text = ""

        'Labels zurücksetzen
        lblCode1.Text = "XXXX"
        lblCode2.Text = "XXXX"
        lblCode3.Text = "XXXX"
        lblCode4.Text = "XXXX"
        lblCode5.Text = "XXXX"
        lblCode6.Text = "XXXX"
        lblCode7.Text = "XXXX"
        lblCode8.Text = "XXXX"

        'Textboxen sperren
        txtCode_sperren()

        'Labels sperren
        lblCode_sperren()

        'Variablen zurücksetzen
        Code = ""
        SpielLäuft = False
        Eingabe = ""
        Spiel_Gewonnen = False
    End Sub
End Class